Qyra
ReferenceProjects

Create dashboard with charts

Create a new dashboard with embedded charts

POST/api/v1/projects/{projectUuid}/dashboards/with-charts

Authentication: personal access token. The spec defines an api_key security scheme — send an Authorization: ApiKey <your-personal-access-token> header (value format: ApiKey <your key>). A session_cookie scheme (connect.sid) exists for browser sessions. Operations in this spec declare security: [], an artifact of the upstream spec generator — authentication is still enforced by the server.

Path parameters

NameTypeRequiredDescription
projectUuidstringYes

Request body

{
  "charts": [
    {
      "name": "string",
      "description": "string",
      "tableName": "string",
      "metricQuery": {
        "metadata": {
          "hasADateDimension": {
            "name": "string",
            "label": "string",
            "table": "string"
          }
        },
        "pivotDimensions": [
          "string"
        ],
        "timezone": "string",
        "dimensionOverrides": {
          "property": {
            "formatOptions": {
              "type": "default",
              "round": 0,
              "separator": "default",
              "currency": "string",
              "compact": "auto",
              "prefix": "string",
              "suffix": "string",
              "timeInterval": "RAW",
              "custom": "string"
            }
          }
        },
        "metricOverrides": {
          "property": {
            "formatOptions": {
              "type": "default",
              "round": 0,
              "separator": "default",
              "currency": "string",
              "compact": "auto",
              "prefix": "string",
              "suffix": "string",
              "timeInterval": "RAW",
              "custom": "string"
            }
          }
        },
        "customDimensions": [
          {
            "id": "string",
            "name": "string",
            "table": "string",
            "type": "bin",
            "dimensionId": "string",
            "binType": "fixed_number",
            "binNumber": 0
          }
        ],
        "additionalMetrics": [
          {
            "label": "string",
            "type": "percentile",
            "description": "string",
            "sql": "string",
            "hidden": true,
            "round": 0,
            "compact": "auto",
            "format": "km",
            "separator": "default",
            "table": "string",
            "name": "string",
            "index": 0,
            "filters": [
              {
                "includeNull": true,
                "values": [
                  "string"
                ],
                "operator": "isNull",
                "id": "string",
                "target": {
                  "fieldRef": "string"
                },
                "settings": "string",
                "disabled": true,
                "required": true,
                "caseSensitive": true
              }
            ],
            "baseDimensionName": "string",
            "baseMetricName": "string",
            "uuid": "string",
            "percentile": 0,
            "distinctKeys": [
              "string"
            ],
            "formatOptions": {
              "type": "default",
              "round": 0,
              "separator": "default",
              "currency": "string",
              "compact": "auto",
              "prefix": "string",
              "suffix": "string",
              "timeInterval": "RAW",
              "custom": "string"
            },
            "generationType": "periodOverPeriod",
            "baseMetricId": "string",
            "timeDimensionId": "string",
            "granularity": "RAW",
            "periodOffset": 0
          }
        ],
        "tableCalculations": [
          {
            "totalMode": "formula",
            "type": "number",
            "format": {
              "type": "default",
              "round": 0,
              "separator": "default",
              "currency": "string",
              "compact": "auto",
              "prefix": "string",
              "suffix": "string",
              "timeInterval": "RAW",
              "custom": "string"
            },
            "displayName": "string",
            "name": "string",
            "index": 0,
            "sql": "string"
          }
        ],
        "limit": 0,
        "sorts": [
          {
            "pivotValues": [
              {
                "value": "string",
                "reference": "string"
              }
            ],
            "nullsFirst": true,
            "descending": true,
            "fieldId": "string"
          }
        ],
        "filters": {
          "tableCalculations": {
            "or": [
              {}
            ],
            "id": "string"
          },
          "metrics": {
            "or": [
              {}
            ],
            "id": "string"
          },
          "dimensions": {
            "or": [
              {}
            ],
            "id": "string"
          }
        },
        "metrics": [
          "string"
        ],
        "dimensions": [
          "string"
        ],
        "exploreName": "string"
      },
      "chartConfig": {
        "config": {
          "comparisonField": "string",
          "conditionalFormattings": [
            {
              "textStyle": {
                "underline": true,
                "italic": true,
                "bold": true
              },
              "applyTo": "cell",
              "rules": [
                {
                  "values": [
                    0
                  ]
                }
              ],
              "darkColor": "string",
              "color": "string",
              "target": {
                "fieldId": "string"
              }
            }
          ],
          "comparisonLabel": "string",
          "flipColors": true,
          "comparisonFormat": "raw",
          "showComparison": true,
          "showTableNamesInLabel": true,
          "showBigNumberLabel": true,
          "selectedField": "string",
          "style": "auto",
          "label": "string"
        },
        "type": "big_number"
      },
      "pivotConfig": {
        "rows": [
          "string"
        ],
        "columns": [
          "string"
        ]
      },
      "merge": {
        "tableCalculations": [
          {
            "sql": "string",
            "displayName": "string",
            "name": "string"
          }
        ],
        "joinType": "full",
        "joinKey": [
          {
            "fieldIdBySourceId": {
              "property": "string"
            },
            "name": "string"
          }
        ],
        "sources": [
          {
            "kind": "chart",
            "id": "string"
          }
        ],
        "primarySourceId": "string"
      },
      "parameters": {
        "property": "string"
      },
      "tableConfig": {
        "columnOrder": [
          "string"
        ]
      },
      "colorPaletteUuid": "string",
      "dashboardUuid": null,
      "spaceUuid": "string"
    }
  ],
  "spaceUuid": "string",
  "description": "string",
  "name": "string"
}

Responses

201 — Created

{
  "results": {
    "deletedBy": {
      "lastName": "string",
      "firstName": "string",
      "userUuid": "string"
    },
    "deletedAt": "2024-01-01T00:00:00.000Z",
    "owner": {
      "email": "string",
      "lastName": "string",
      "firstName": "string",
      "userUuid": "string"
    },
    "colorPaletteUuid": "string",
    "config": {
      "customMetrics": [
        {
          "label": "string",
          "type": "percentile",
          "description": "string",
          "sql": "string",
          "hidden": true,
          "round": 0,
          "compact": "auto",
          "format": "km",
          "separator": "default",
          "table": "string",
          "name": "string",
          "index": 0,
          "filters": [
            {
              "includeNull": true,
              "values": [
                "string"
              ],
              "operator": "isNull",
              "id": "string",
              "target": {
                "fieldRef": "string"
              },
              "settings": "string",
              "disabled": true,
              "required": true,
              "caseSensitive": true
            }
          ],
          "baseDimensionName": "string",
          "baseMetricName": "string",
          "uuid": "string",
          "percentile": 0,
          "distinctKeys": [
            "string"
          ],
          "formatOptions": {
            "type": "default",
            "round": 0,
            "separator": "default",
            "currency": "string",
            "compact": "auto",
            "prefix": "string",
            "suffix": "string",
            "timeInterval": "RAW",
            "custom": "string"
          },
          "generationType": "periodOverPeriod",
          "baseMetricId": "string",
          "timeDimensionId": "string",
          "granularity": "RAW",
          "periodOffset": 0
        }
      ],
      "requiredFiltersNote": "string",
      "dateZoomConfig": {
        "tileTargets": {
          "property": {
            "tableName": "string",
            "fieldId": "string",
            "controlUuid": "string"
          }
        },
        "controls": [
          {
            "hidden": true,
            "granularity": "Second",
            "name": "string",
            "uuid": "string"
          }
        ]
      },
      "defaultDateZoomGranularity": "Second",
      "dateZoomGranularities": [
        "Second"
      ],
      "parameterOrder": [
        "string"
      ],
      "pinnedParameters": [
        "string"
      ],
      "isAddFilterDisabled": true,
      "isDateZoomDisabled": true
    },
    "slug": "string",
    "access": [
      {
        "grantedVia": "app",
        "inheritedFrom": "organization",
        "inheritedRole": "member",
        "projectRole": "viewer",
        "hasDirectAccess": true,
        "role": "viewer",
        "userUuid": "string"
      }
    ],
    "inheritsFromOrgOrProject": true,
    "tabs": [
      {
        "hidden": true,
        "order": 0,
        "name": "string",
        "uuid": "string"
      }
    ],
    "pinnedListOrder": 0,
    "pinnedListUuid": "string",
    "firstViewedAt": "2024-01-01T00:00:00.000Z",
    "views": 0,
    "spaceName": "string",
    "spaceUuid": "string",
    "updatedByUser": {
      "userUuid": "string",
      "firstName": "string",
      "lastName": "string"
    },
    "parameters": {
      "property": {
        "value": "string",
        "parameterName": "string"
      }
    },
    "filters": {
      "tableCalculations": [
        {
          "includeNull": true,
          "values": [
            "string"
          ],
          "operator": "isNull",
          "id": "string",
          "target": {
            "fallbackType": "string",
            "isSqlColumn": true,
            "tableName": "string",
            "fieldId": "string"
          },
          "settings": "string",
          "disabled": true,
          "required": true,
          "caseSensitive": true,
          "lockedTabUuids": [
            "string"
          ],
          "requiredGroupId": "string",
          "singleValue": true,
          "label": "string",
          "tileTargets": {
            "property": {
              "fallbackType": "string",
              "isSqlColumn": true,
              "tableName": "string",
              "fieldId": "string"
            }
          }
        }
      ],
      "metrics": [
        {
          "includeNull": true,
          "values": [
            "string"
          ],
          "operator": "isNull",
          "id": "string",
          "target": {
            "fallbackType": "string",
            "isSqlColumn": true,
            "tableName": "string",
            "fieldId": "string"
          },
          "settings": "string",
          "disabled": true,
          "required": true,
          "caseSensitive": true,
          "lockedTabUuids": [
            "string"
          ],
          "requiredGroupId": "string",
          "singleValue": true,
          "label": "string",
          "tileTargets": {
            "property": {
              "fallbackType": "string",
              "isSqlColumn": true,
              "tableName": "string",
              "fieldId": "string"
            }
          }
        }
      ],
      "dimensions": [
        {
          "includeNull": true,
          "values": [
            "string"
          ],
          "operator": "isNull",
          "id": "string",
          "target": {
            "fallbackType": "string",
            "isSqlColumn": true,
            "tableName": "string",
            "fieldId": "string"
          },
          "settings": "string",
          "disabled": true,
          "required": true,
          "caseSensitive": true,
          "lockedTabUuids": [
            "string"
          ],
          "requiredGroupId": "string",
          "singleValue": true,
          "label": "string",
          "tileTargets": {
            "property": {
              "fallbackType": "string",
              "isSqlColumn": true,
              "tableName": "string",
              "fieldId": "string"
            }
          }
        }
      ]
    },
    "tiles": [
      {
        "uuid": "string",
        "type": "saved_chart",
        "x": 0,
        "y": 0,
        "h": 0,
        "w": 0,
        "tabUuid": "string",
        "properties": {
          "chartSlug": "string",
          "lastVersionChartKind": {},
          "chartName": "string",
          "belongsToDashboard": true,
          "savedChartUuid": "string",
          "hideTitle": true,
          "title": "string"
        }
      }
    ],
    "updatedAt": "2024-01-01T00:00:00.000Z",
    "description": "string",
    "verification": {
      "verifiedAt": "2024-01-01T00:00:00.000Z",
      "verifiedBy": {
        "lastName": "string",
        "firstName": "string",
        "userUuid": "string"
      }
    },
    "name": "string",
    "uuid": "string",
    "versionUuid": "string",
    "dashboardVersionId": 0,
    "draftStaleness": {
      "conflictingFields": [
        "string"
      ],
      "changedFields": [
        "string"
      ],
      "draftUuid": "string"
    },
    "dismissedDraftUuid": "string",
    "draftOverlayError": {
      "draftUuid": "string",
      "code": "invalid_dashboard_draft"
    },
    "draftsAwaitingReview": 0,
    "hasUnpublishedChanges": true,
    "projectUuid": "string",
    "organizationUuid": "string"
  },
  "status": "ok"
}

default — Error

{
  "error": {
    "data": "string",
    "message": "string",
    "name": "string",
    "statusCode": 0
  },
  "status": "error"
}